/*
 * This program tests the operation of the USART serial driver.
 * @author Ryan Hall
 */
program TestUSART {

    entrypoint main = TestUSART.start;
    entrypoint usart0_rx = USART0.rec_handler;
    entrypoint usart0_udre = USART0.tran_handler;
}

component TestUSART {

    field t_buf : char[] = "Hello World!";
    field r_buf : char[] = new char[10];
    field i : int = 0;

    method start() {
	Mica2.startTerminal();
     
        while (true) {
            MCU.sleepTransfer(t_buf, 0, t_buf.length, USART0.transmit);
            USART0.receive(r_buf, 0, r_buf.length);
            MCU.sleep();
        }
    }
}
